/*

Fast image steganography routines and classes

(c)  2009 Alexander Myasnikov

Russia, Vladimir region, Kolchugino

Uses 9 bits of one pixel, 3 bit of one color and 24-bit images.

i.e. for one byte is needed only 0,88 pixels.

WEB: www.darksoftware.narod.ru

E-mail: darksoftware@ya.ru

Free for non-commercial usage

If you like this code and want to use it

in commercial software, please contact author.

 */

// ---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
#include "gstego.h"
// ---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

// ---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner) : TForm(Owner) {
}

int FileSizeByName(String fn) {

	TFileStream *fs = new TFileStream(fn, fmOpenRead);
	int Result = fs->Size;
	delete fs;

	return Result;

}

// ---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender) {

	TIMFile *im = new TIMFile();
	TOpenDialog *od = new TOpenDialog(NULL);

	od->Title = "Select source image";
	od->Filter = "*.bmp|*.bmp";

	if (od->Execute()) {

		im->stegotype = bitusage->ItemIndex;
		im->LoadImageA(od->FileName);

		od->Title = "Select data file to hide it";
		od->Filter = "*.*|*.*";
		if (od->Execute()) {

			int maxsize = im->Estimated;

			int fs = FileSizeByName(od->FileName);

			if (fs <= maxsize) {

				im->LoadToBA(od->FileName);
				im->Inject();

				TSaveDialog *sd = new TSaveDialog(NULL);

				sd->Title = "Select target image";
				sd->Filter = "*.bmp|*.bmp";
				sd->DefaultExt = "bmp";

				if (sd->Execute()) {

					im->SaveImage(sd->FileName);

				}

				delete sd;

			}
			else {
				TVarRec vr[] = {
					fs, maxsize
				};
				ShowMessage(Format("File too large: %d, but limit is %d", vr, 2)
					);
			}

		}

	}

	delete od;
	delete im;

}

// ---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender) {

	TIMFile *imc = new TIMFile();

	TOpenDialog *od = new TOpenDialog(NULL);

	od->Title = "Select stego image";
	od->Filter = "*.bmp|*.bmp";
	if (od->Execute()) {

		imc->stegotype = bitusage->ItemIndex;

		if (imc->CheckHeader(od->FileName)) {

			imc->LoadImageA(od->FileName);
			imc->Catch();

			TSaveDialog *sd = new TSaveDialog(NULL);

			sd->Title = "Select target data file";
			sd->Filter = "*.*|*.*";

			if (sd->Execute()) {

				imc->SaveToBA(sd->FileName);
			}

			delete sd;

		}
		else {

			ShowMessage("Not hidden data found!");

		}

	}

	delete imc;
}

// ---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender) {

	TIMFile *im = new TIMFile();
	TOpenDialog *od = new TOpenDialog(NULL);

	od->Title = "Select source image";
	od->Filter = "*.bmp|*.bmp";

	if (od->Execute()) {

		im->stegotype = bitusage->ItemIndex;
		im->LoadImageA(od->FileName);
		int maxsize = im->Estimated;

		TVarRec vr[] = {
			maxsize
		};
		ShowMessage(Format("Limit is %d", vr, 2));

	}

	delete od;

}
// ---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{
Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::About1Click(TObject *Sender)
{
ShowMessage("TIMFile image stego routines\n(c) 2009-2010 Alexander Myasnikov");
}
//---------------------------------------------------------------------------

